﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

public partial class Default2 : System.Web.UI.Page
{
    public void Page_Init(object sender, EventArgs e)  
    {  
        RadGrid RadGrid1 = new RadGrid();  
        RadGrid1.ID = "RadGrid1";  
        RadGrid1.AllowSorting = true;  
        RadGrid1.AutoGenerateColumns = false;  
        RadGrid1.MasterTableView.Columns.Add(new MyColumn("ID"));  
        RadGrid1.MasterTableView.Columns.Add(new MyColumn("Name"));  
        RadGrid1.NeedDataSource += new GridNeedDataSourceEventHandler(RadGrid1_NeedDataSource);  
        PlaceHolder1.Controls.Add(RadGrid1);  
    }  
  
    void RadGrid1_NeedDataSource(object source, GridNeedDataSourceEventArgs e)  
    {  
        ((RadGrid)source).DataSource = MyData;  
    }  
  
    public List<MyObject> MyData  
    {  
        get   
        {  
            List<MyObject> list = new List<MyObject>();  
  
            for (var i = 0; i < 10; i++)  
            {  
                list.Add(new MyObject(i, String.Format("Name{0}", i.ToString())));  
            }  
  
            return list;  
        }  
    }  
  
    public class MyObject  
    {  
        public MyObject(int id, string name)  
        {  
            ID = id;  
            Name = name;  
        }  
  
        public int ID { get; set; }  
        public string Name { get; set; }  
    }

    public class MyColumn : GridBoundColumn
    {
        public MyColumn(string dataField)
        {
            DataField = HeaderText = SortExpression = UniqueName = dataField;
        }

        public override void InitializeCell(TableCell cell, int columnIndex, GridItem inItem)
        {
            base.InitializeCell(cell, columnIndex, inItem);

            if (inItem is GridDataItem)
            {
                CreateToolTip(cell, false);
                cell.DataBinding += new EventHandler(cell_DataBinding);
            }
        }

        void cell_DataBinding(object sender, EventArgs e)
        {
            CreateToolTip((TableCell)sender, true);
        }

        public void CreateToolTip(TableCell cell, bool shouldDataBind)
        {
            GridDataItem item = (GridDataItem)cell.Parent;
            string ID = String.Format("{0}_{1}", item.ItemIndexHierarchical, DataField);
            RadToolTip toolTip = (RadToolTip)item.FindControl(ID);
            if (toolTip == null)
            {
                string value = FormatDataValue(DataBinder.Eval(item.DataItem, DataField), item);

                Label Label1 = new Label();
                Label1.ID = String.Format("{0}_Label", ID);
                cell.Controls.Add(Label1);

                toolTip = new RadToolTip();
                toolTip.ID = String.Format("{0}_{1}", item.ItemIndexHierarchical, DataField);
                toolTip.TargetControlID = Label1.ID;
                cell.Controls.Add(toolTip);

                if (shouldDataBind)
                {
                    Label1.Text = value;
                    toolTip.Text = String.Format("ToolTip for " + DataField + ": <b>{0}</b> ", value);
                }

            }
        }
    }
}
